<?php

/*
=====================================================
ExpressionEngine - by Denik
-----------------------------------------------------
http://denik.od.ua/
-----------------------------------------------------
Copyright (c) 2007 - 2008 Denik, Inc.
=====================================================
File: mcp.menu_builder.php
-----------------------------------------------------
Purpose: Fortunes module - CP
=====================================================
*/

class Menu_builder_CP {

    var $version        = '0.1';
    
    
    // -------------------------
    //  Constructor
    // -------------------------
    function Menu_builder_CP ($switch = TRUE)
    {
        global $IN;
        
        if ($switch)
        {
            switch($IN->GBL('P'))
            {
                 case 'CreateMenu'      :    $this->CreateMenu();
                     break;
                 case 'LinkEdit'        :    $this->LinkEdit($IN->GBL('menu_id'));
                     break;
                 case 'EditMenu'        :    $this->EditMenu($IN->GBL('menu_id'));
                     break;
                 case 'Links'           :    $this->Links($IN->GBL('menu_id'));
                     break;
                 default                :    $this->home();
                     break;
            }
        }
    }
    // END
    
    
    // ----------------------------------------
    //  Выводит список меню
    // ----------------------------------------
    function home()
    {
        global $DSP, $LANG, $DB, $IN;
        
        
		// Удаление меню (по требованию)
		if (isset($_GET['act']) && $IN->GBL('act') == "DeleteMenu")
		{
			$DB->query("DELETE FROM exp_menu_builder WHERE menu_id='{$IN->GBL('menu_id')}'");
			$DB->query("DELETE FROM exp_menu_builder_links WHERE menu_id='{$IN->GBL('menu_id')}'");
		}
        
        // Получение списка меню с БД
        $sql = "SELECT menu_id, 
			           menu_name,
			           menu_alias 
					FROM exp_menu_builder";			
		$menu = $DB->query($sql);
        
        $DSP->title = $LANG->line('menu_builder_name');
        
        // Вывод лог. структуры
        $DSP->crumb = $DSP->anchor(BASE.
                                   AMP.'C=modules'.
                                   AMP.'M=Menu_builder',
                                   $LANG->line('menu_builder_module_name'));
        $DSP->crumb .= $DSP->crumb_item($LANG->line('menu_builder_menu'));
        
		//$DSP->body .= $DSP->heading($LANG->line('fortunes_menu'));

		// Кнопка "Создать меню":
		$DSP->body .= $DSP->right_crumb($LANG->line('menu_builder_create'),
										BASE.AMP.'C=modules'.
										AMP.'M=Menu_builder'.
										AMP.'P=CreateMenu', 
										'', FALSE);
		
		// Заголовок таблицы
		$DSP->body .= $DSP->qdiv('tableHeading', $LANG->line('menu_builder_menu'));
		// Таблица со списком созданных меню
		$DSP->body .= $DSP->table_open(array('class' => "tableBorder", 'width' => "100%"));
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => "tableHeadingAlt", 'width'=>"30px", 'text' => "ID"),
				'cell2' => array('class' => "tableHeadingAlt", 'text' => $LANG->line('menu_builder_menu_name')),
				'cell3' => array('class' => "tableHeadingAlt", 'colspan'=>"4", 'text' => $LANG->line('menu_builder_menu_alias'))));
		if ($menu->num_rows > 0)
		{
			foreach ($menu->result as $key=>$val)
			{
				$class = ($key % 2) ? "tableCellOne" : "tableCellTwo";
				$DSP->body .= $DSP->table_row(array(
						'cell1' => array('class'  => $class, 'text' => $DSP->qspan('default', $key)),
						'cell2' => array('class'  => $class, 'text' => $DSP->qspan('defaultBold', $val['menu_name'])),
						'cell3' => array('class'  => $class, 'text' => $DSP->qspan('default', $val['menu_alias'])),
						'cell4' => array('class'  => $class, 
										 'text' => $DSP->anchor(BASE.
	                                   						AMP.'C=modules'.
	                                   						AMP.'M=Menu_builder'.
	                                   						AMP.'P=Links'.
	                                   						AMP.'menu_id='.$val['menu_id'],
	                                   						$LANG->line('menu_builder_links'))),
						'cell5' => array('class'  => $class, 
										 'text' => $DSP->anchor(BASE.
	                                   						AMP.'C=modules'.
	                                   						AMP.'M=Menu_builder'.
	                                   						AMP.'P=EditMenu'.
	                                   						AMP.'menu_id='.$val['menu_id'],
	                                   						$LANG->line('menu_builder_edit'))),
	                   	'cell6' => array('class'  => $class, 
										 'text' => $DSP->anchor(BASE.
	                                   						AMP.'C=modules'.
	                                   						AMP.'M=Menu_builder'.
	                                   						AMP.'act=DeleteMenu'.
	                                   						AMP.'menu_id='.$val['menu_id'],
	                                   						$LANG->line('menu_builder_delete'))) ));
			}
		}
		else
		{
			$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => "tableCellOne", 'text' => $LANG->line('menu_builder_menu_not_found'), 'align'=>"center", 'colspan'=>"6") ));
		}
		$DSP->body .= $DSP->table_close(FALSE);		
    }
    // END
    
    
    
    // ----------------------------------------
    //  Создание меню
    // ----------------------------------------
    function CreateMenu()
    {
    	global $DSP, $LANG, $DB;
        
        $DSP->title = $LANG->line('menu_builder_name');
        
        // Вывод лог. структуры
        $DSP->crumb = $DSP->anchor(BASE.
                                   AMP.'C=modules'.
                                   AMP.'M=Menu_builder',
                                   $LANG->line('menu_builder_module_name'));
        $DSP->crumb .= $DSP->crumb_item($LANG->line('menu_builder_create'));
        
        
        if (isset($_POST["menu_name"]) && isset($_POST["menu_alias"]))
        {
        	if ($this->DoCreateMenu())
			{
				$DSP->body .= $DSP->qdiv('box', $DSP->qdiv('success', $LANG->line('menu_builder_created')));
			}
			else
			{
				$DSP->body .= $DSP->qdiv('box', $DSP->qdiv('alert', $LANG->line('menu_builder_not_created')));
			}
		}
        
        // Опции меню
        $DSP->body .= $DSP->form('C=modules'.AMP.'M=Menu_builder'.AMP.'P=CreateMenu', 'CreateMenuForm');
        $DSP->body .= $DSP->table('tableBorder', '0', '0', '100%').
              $DSP->tr().
              $DSP->table_qcell('tableHeadingAlt',
                                array(
                                       $LANG->line('menu_builder_option'),
                                       $LANG->line('menu_builder_setup')
                                     )
                                ).$DSP->tr_c();
        $DSP->body .= $DSP->tr().
              $DSP->table_qcell('tableCellTwo',
                                array(
                                       $DSP->qspan('defaultBold', $LANG->line('menu_builder_menu_name')),
                                       $DSP->input_text('menu_name', '', 15, 254, 'input', '260px', '', true)
                                     )
                                ).$DSP->tr_c();
        $DSP->body .= $DSP->tr().
              $DSP->table_qcell('tableCellOne',
                                array(
                                       $DSP->qspan('defaultBold', $LANG->line('menu_builder_menu_alias')),
                                       $DSP->input_text('menu_alias', '', 15, 254, 'input', '260px', '', true)
                                     )
                                ).$DSP->tr_c();
        $DSP->body .= $DSP->table_c();
        $DSP->body .= $DSP->input_submit($LANG->line('menu_builder_menu_submit'));   
        $DSP->body .= $DSP->form_c();
	}
	
    // ----------------------------------------
    //  Создание меню - POST
    // ----------------------------------------
    function DoCreateMenu()
    {
    	global $DB;
    	
    	$name  = $_POST["menu_name"];
    	$alias = $_POST["menu_alias"];
    	
    	if ($name=='' or $alias=='') return FALSE;
    	
    	// Получение списка меню с БД
        $sql = "SELECT menu_id, 
			           menu_name,
			           menu_alias 
					FROM exp_menu_builder WHERE menu_alias='$alias'";			
		$query = $DB->query($sql);
		
		if ($query->num_rows > 0) Return FALSE;
    	
    	$sql = "INSERT INTO exp_menu_builder (menu_id,
                                         menu_name,
                                         menu_alias)
                                         VALUES
                                         (NULL,
                                         '$name',
                                         '$alias')";
		$DB->query($sql);
    	
    	Return TRUE;
	}
    
    // ----------------------------------------
    //  Изменение меню
    // ----------------------------------------
    function EditMenu($id = 0)
    {
    	global $DSP, $LANG, $DB;
        
        // Заголовок
        $DSP->title = $LANG->line('menu_builder_name');
        // Вывод лог. структуры
        $DSP->crumb = $DSP->anchor(BASE.
                                   AMP.'C=modules'.
                                   AMP.'M=Menu_builder',
                                   $LANG->line('menu_builder_module_name'));
        $DSP->crumb .= $DSP->crumb_item($LANG->line('menu_builder_edit'));
        
        
        if (isset($_POST["menu_name"]) && isset($_POST["menu_alias"]))
        {
        	if ($this->DoEditMenu($id))
			{
				$DSP->body .= $DSP->qdiv('box', $DSP->qdiv('success', $LANG->line('menu_builder_saved')));
			}
			else
			{
				$DSP->body .= $DSP->qdiv('box', $DSP->qdiv('alert', $LANG->line('menu_builder_not_saved')));
			}
		}
		
        // Получение списка меню с БД
        $sql = "SELECT menu_id, 
			           menu_name,
			           menu_alias 
					FROM exp_menu_builder WHERE menu_id='$id'";			
		$query = $DB->query($sql);
		$name  = $query->row['menu_name'];
		$alias = $query->row['menu_alias'];
        
        // Опции меню
        $DSP->body .= $DSP->form('C=modules'.AMP.'M=Menu_builder'.AMP.'P=EditMenu'.AMP."menu_id=$id", 'CreateMenuForm');
        $DSP->body .= $DSP->table('tableBorder', '0', '0', '100%').
              $DSP->tr().
              $DSP->table_qcell('tableHeadingAlt',
                                array(
                                       $LANG->line('menu_builder_option'),
                                       $LANG->line('menu_builder_setup')
                                     )
                                ).$DSP->tr_c();
        $DSP->body .= $DSP->tr().
              $DSP->table_qcell('tableCellTwo',
                                array(
                                       $DSP->qspan('defaultBold', $LANG->line('menu_builder_menu_name')),
                                       $DSP->input_text('menu_name', $name, 15, 254, 'input', '260px', '', true)
                                     )
                                ).$DSP->tr_c();
        $DSP->body .= $DSP->tr().
              $DSP->table_qcell('tableCellOne',
                                array(
                                       $DSP->qspan('defaultBold', $LANG->line('menu_builder_menu_alias')),
                                       $DSP->input_text('menu_alias', $alias, 15, 254, 'input', '260px', '', true)
                                     )
                                ).$DSP->tr_c();
        $DSP->body .= $DSP->table_c();
        $DSP->body .= $DSP->input_submit($LANG->line('menu_builder_menu_edit_submit'));   
        $DSP->body .= $DSP->form_c();
	}
	
    // ----------------------------------------
    //  Изменение меню - POST
    // ----------------------------------------
    function DoEditMenu($id = 0)
    {
    	global $DB;
    	
    	$name  = $_POST["menu_name"];
    	$alias = $_POST["menu_alias"];
    	
    	if ($name=='' or $alias=='') return FALSE;
    	
    	if ($id == 0) Return FALSE;
    	
    	$sql = "UPDATE exp_menu_builder SET `menu_name`='$name',
                                         	`menu_alias`='$alias'
                                        WHERE menu_id='$id'";
		$DB->query($sql);
    	
    	Return TRUE;
	}
    

    // ----------------------------------------
    //  Редактор списка ссылок в меню
    // ----------------------------------------
    function Links($menu_id)
    {
        global $DSP, $LANG, $DB, $IN;


		// Удаление пункта меню (по требованию)
		if (isset($_GET['act']) && $IN->GBL('act') == "DeleteLink")
		{
			$DB->query("DELETE FROM exp_menu_builder_links WHERE link_id='{$IN->GBL('link_id')}'");
		}

		// Упорядочивание пунктов меню
        if (isset($_POST["link_num"]))
        {
        	//print_r($_POST["link_num"]);
        	foreach( $_POST["link_num"] as $key=>$val )
        		$sql[] = "UPDATE exp_menu_builder_links SET link_num='$val' WHERE link_id='$key'";

			foreach ($sql as $query)
			{
				$DB->query($query);
			}
		}
        
        // Получение текущего меню с БД
        $sql = "SELECT menu_name 
					FROM exp_menu_builder WHERE menu_id='$menu_id'";			
		$menu = $DB->query($sql);
        
        // Получение списка линков с БД
        $sql = "SELECT link_num,
        			   link_id,
        			   link_text 
					FROM exp_menu_builder_links WHERE menu_id='$menu_id'";			
		$link = $DB->query($sql);
        sort($link->result);
        
        // Заголовок сайта
        $DSP->title = $LANG->line('menu_builder_name');
        // Вывод лог. структуры
        $DSP->crumb = $DSP->anchor(BASE.
                                   AMP.'C=modules'.
                                   AMP.'M=Menu_builder',
                                   $LANG->line('menu_builder_module_name'));
        $DSP->crumb .= $DSP->crumb_item($DSP->qspan('defaultBold', $menu->row["menu_name"]));

		// Кнопка "Добавить линк":
		$DSP->body .= $DSP->right_crumb($LANG->line('menu_builder_link_add'),
										BASE.AMP.'C=modules'.
										AMP.'M=Menu_builder'.
										AMP.'P=LinkEdit'.
										AMP.'act=New'.
										AMP.'menu_id='.$menu_id,
										'', FALSE);
		
		// Заголовок таблицы
		$DSP->body .= $DSP->qdiv('tableHeading', $LANG->line('menu_builder_link_tabl').' "'.$menu->row["menu_name"].'"');
		// Таблица со списком созданных линков
		$DSP->body .= $DSP->form('C=modules'.AMP.'M=Menu_builder'.AMP.'P=Links'.AMP."menu_id=$menu_id", 'LinkMenuForm');
		$DSP->body .= $DSP->table_open(array('class' => "tableBorder", 'width' => "100%"));
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => "tableHeadingAlt", 'text' => $LANG->line('menu_builder_link_num'), 'width'=>"100px"),
				'cell2' => array('class' => "tableHeadingAlt", 'text' => $LANG->line('menu_builder_link_name'), 'colspan'=>"3") ));
		if ($link->num_rows > 0)
		{
			foreach ($link->result as $key=>$val)
			{
				$class = ($key % 2) ? "tableCellOne" : "tableCellTwo";
				$DSP->body .= $DSP->table_row(array(
						'cell1' => array('class'  => $class, 'text' => $DSP->input_text("link_num[{$val['link_id']}]", $val['link_num'], 15, 254, 'input', '50px', '', true)),
						'cell2' => array('class'  => $class, 'text' => $DSP->qspan('defaultBold', $val['link_text'])),
						'cell3' => array('class'  => $class, 
										 'text' => $DSP->anchor(BASE.
															AMP.'C=modules'.
															AMP.'M=Menu_builder'.
															AMP.'P=LinkEdit'.
															AMP.'act=Edit'.
															AMP.'menu_id='.$menu_id.
															AMP.'link_id='.$val['link_id'],
															$LANG->line('menu_builder_edit'))),
						'cell4' => array('class'  => $class, 
										 'text' => $DSP->anchor(BASE.
															AMP.'C=modules'.
															AMP.'M=Menu_builder'.
															AMP.'P=Links'.
															AMP.'menu_id='.$menu_id.
															AMP.'act=DeleteLink'.
															AMP.'link_id='.$val['link_id'],
															$LANG->line('menu_builder_delete'))) ));
			}
		}
		else
		{
			$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => "tableCellOne", 'text' => $LANG->line('menu_builder_link_not_found'), 'align'=>"center", 'colspan'=>"4") ));
		}
		$DSP->body .= $DSP->table_close(FALSE);	
		$DSP->body .= $DSP->input_submit($LANG->line('menu_builder_menu_edit_submit'));	
		$DSP->body .= $DSP->form_c();
    }
    
    
    // ----------------------------------------
    //  Создание|Редактирование ссылок
    // ----------------------------------------
    function LinkEdit($menu_id)
    {
    	global $DSP, $LANG, $DB, $IN;
        
        // Заголовок
        $DSP->title = $LANG->line('menu_builder_name');
        // Вывод лог. структуры
        $DSP->crumb = $DSP->anchor(BASE.
                                   AMP.'C=modules'.
                                   AMP.'M=Menu_builder',
                                   $LANG->line('menu_builder_module_name'));
                                   
        // Получение текущего меню с БД
        $sql = "SELECT menu_name 
					FROM exp_menu_builder WHERE menu_id='$menu_id'";			
		$menu = $DB->query($sql);
		// Вывод его в логическую структуру                           
		$DSP->crumb .= $DSP->crumb_item($DSP->anchor(BASE.
												AMP.'C=modules'.
												AMP.'M=Menu_builder'.
												AMP.'P=Links'.
												AMP.'menu_id='.$menu_id,
                                   				$menu->row["menu_name"]));
        
        // Входящие зависиммости
        if ($IN->GBL('act') == "New")  // создание новой ссылки
        {
        	$form_link = 'C=modules'.AMP.'M=Menu_builder'.AMP.'P=LinkEdit'.AMP.'act=New'.AMP.'menu_id='.$menu_id;
        	$submit = $LANG->line('menu_builder_menu_submit');
        	$DSP->crumb .= $DSP->crumb_item($LANG->line('menu_builder_link_add'));
        	$link["link_text"] = '';
        	$link["link_title"] = '';
        	$link["link_href"] = '';
        	
        	// Обработка запроса (создание)
        	if (isset($_POST["link_text"]))
        	{
				if ($this->DoCreateLink($menu_id))
				{
					$DSP->body .= $DSP->qdiv('box', $DSP->qdiv('success', $LANG->line('menu_builder_link_created')));
				}
				else
				{
					$DSP->body .= $DSP->qdiv('box', $DSP->qdiv('alert', $LANG->line('menu_builder_link_not_created')));
				}
			}
		}
		else        // редактирование ссылки
		{
			$form_link = 'C=modules'.AMP.'M=Menu_builder'.AMP.'P=LinkEdit'.AMP.'act=Edit'.AMP.'menu_id='.$menu_id.AMP.'link_id='.$IN->GBL('link_id');
			$submit = $LANG->line('menu_builder_menu_edit_submit');
			$DSP->crumb .= $DSP->crumb_item($LANG->line('menu_builder_link_edit'));
			
			// Обработка запроса (сохранение)
	      	if (isset($_POST["link_text"]))
        	{
				if ($this->DoEditLink($IN->GBL('link_id')))
				{
					$DSP->body .= $DSP->qdiv('box', $DSP->qdiv('success', $LANG->line('menu_builder_link_saved')));
				}
				else
				{
					$DSP->body .= $DSP->qdiv('box', $DSP->qdiv('alert', $LANG->line('menu_builder_link_not_saved')));
				}
			}
			// Получение текущего линка из БД
			$sql = "SELECT link_text,
						   link_title,
						   link_href,
						   menu_id
						FROM exp_menu_builder_links WHERE link_id='{$IN->GBL('link_id')}'";			
			$link = $DB->query($sql);
			$link = $link->row;
		}        
        
        // Начало формы редактирования линков
        $DSP->body .= $DSP->form($form_link, 'FormEditLinks');
        $DSP->body .= $DSP->table('tableBorder', '0', '0', '100%').
              $DSP->tr().
              $DSP->table_qcell('tableHeadingAlt',
                                array(
                                       $LANG->line('menu_builder_option'),
                                       $LANG->line('menu_builder_setup')
                                     )
                                ).$DSP->tr_c();
        $DSP->body .= $DSP->tr().
              $DSP->table_qcell('tableCellTwo',
                                array(
                                       $DSP->qspan('defaultBold', $LANG->line('menu_builder_link_name')),
                                       $DSP->input_text('link_text', $link["link_text"], 15, 254, 'input', '260px', '', true)
                                     )
                                ).$DSP->tr_c();
        $DSP->body .= $DSP->tr().
              $DSP->table_qcell('tableCellOne',
                                array(
                                       $DSP->qspan('defaultBold', $LANG->line('menu_builder_link_title')),
                                       $DSP->input_text('link_title', $link["link_title"], 15, 254, 'input', '260px', '', true)
                                     )
                                ).$DSP->tr_c();
        $DSP->body .= $DSP->tr().
              $DSP->table_qcell('tableCellOne',
                                array(
                                       $DSP->qspan('defaultBold', $LANG->line('menu_builder_link_href')),
                                       $DSP->input_text('link_href', $link["link_href"], 15, 254, 'input', '260px', '', true)
                                     )
                                ).$DSP->tr_c();
        $DSP->body .= $DSP->table_c();
        $DSP->body .= $DSP->input_submit($submit);   
        $DSP->body .= $DSP->form_c();
	}
    
    // ----------------------------------------
    //  Создание пункта меню - POST
    // ----------------------------------------
    function DoCreateLink($menu_id = 0)
    {
    	global $DB;
    	
    	$text  = $_POST["link_text"];
    	$title = $_POST["link_title"];
    	$href  = $_POST["link_href"];
    	
    	$sql = "INSERT INTO exp_menu_builder_links (`link_text`,
												 `link_title`,
												 `link_href`,
												 `menu_id`,
												 `link_num`)
												 VALUES
												 ('$text',
												 '$title',
												 '$href',
												 '$menu_id',
												 '1')";
		$DB->query($sql);
    	
    	Return TRUE;
	}
    
    // ----------------------------------------
    //  Изменение пункта меню - POST
    // ----------------------------------------
    function DoEditLink($id = 0)
    {
    	global $DB;
    	
    	$text  = $_POST["link_text"];
    	$title = $_POST["link_title"];
    	$href  = $_POST["link_href"];
    	
    	$sql = "UPDATE exp_menu_builder_links SET 
    										`link_text`='$text',
    										`link_title`='$title',
                                         	`link_href`='$href'
                                        WHERE `link_id`='$id'";
		$DB->query($sql);
    	
    	Return TRUE;
	}    
    
    
    // ----------------------------------------
    //  Module installer
    // ----------------------------------------

    function menu_builder_module_install()
    {
        global $DB;        
        
        $sql[] = "INSERT INTO exp_modules (module_id,
                                           module_name,
                                           module_version,
                                           has_cp_backend)
                                           VALUES
                                           ('',
                                           'Menu_builder',
                                           '$this->version',
                                           'y')";
                                           
        $sql[] = "CREATE TABLE IF NOT EXISTS `exp_menu_builder` (
                 `menu_id` INT(4) UNSIGNED NOT NULL AUTO_INCREMENT,
                 `menu_name` VARCHAR(255) NOT NULL,
                 `menu_alias` VARCHAR(50) NOT NULL,
                 PRIMARY KEY (`menu_id`));";
                 
        $sql[] = "CREATE TABLE IF NOT EXISTS `exp_menu_builder_links` (
                 `link_id` INT(5) UNSIGNED NOT NULL AUTO_INCREMENT,
                 `menu_id` INT(4) UNSIGNED NOT NULL,
                 `link_num` INT(3),
                 `link_text` TEXT NOT NULL,
                 `link_title` VARCHAR(255),
                 `link_href` VARCHAR(255) NOT NULL,
                 PRIMARY KEY (`link_id`), KEY(`menu_id`));";
    
        foreach ($sql as $query)
        {
            $DB->query($query);
        }
        
        return true;
    }
    // END
    
    
    // ----------------------------------------
    //  Module de-installer
    // ----------------------------------------

    function menu_builder_module_deinstall()
    {
        global $DB;    
      
        $sql[] = "DELETE FROM exp_modules
                  WHERE module_name = 'Menu_builder'";
        
        $sql[] = "DROP TABLE IF EXISTS exp_menu_builder";
                  
        $sql[] = "DROP TABLE IF EXISTS exp_menu_builder_links";

        foreach ($sql as $query)
        {
            $DB->query($query);
        }

        return true;
    }
    // END
}
// END CLASS
?>